Attribute VB_Name = "modTypeLibrary"
'=========================================================================================
' RTF API Module
'=========================================================================================
' Adapted and Modified By: Marc Cramer
' Published Date: 01/15/2001
' WebSite: MKC Computers at http://www.mkccomputers.com
'=========================================================================================
' Based On: VB Type Library Registration Utility
' WebSite: vbAccelerator at http://www.vbaccelerator.com
'=========================================================================================
Option Explicit

Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type
Private Enum eSYSKIND
   SYS_WIN16 = 0&
   SYS_WIN32 = 1&
   SYS_MAC = 2&
End Enum

Private Declare Function LoadTypeLib Lib "oleaut32.dll" (pFileName As Byte, pptlib As Object) As Long
Private Declare Function RegisterTypeLib Lib "oleaut32.dll" (ByVal ptlib As Object, szFullPath As Byte, szHelpFile As Byte) As Long
Private Declare Function UnRegisterTypeLib Lib "oleaut32.dll" (libID As GUID, ByVal wVerMajor As Integer, ByVal wVerMinor As Integer, ByVal lCID As Long, ByVal tSysKind As eSYSKIND) As Long
Private Declare Function CLSIDFromString Lib "ole32.dll" (lpsz As Byte, pclsid As GUID) As Long
Private Declare Function GetFileTitle Lib "comdlg32.dll" Alias "GetFileTitleA" (ByVal lpszFile As String, ByVal lpszTitle As String, ByVal cbBuf As Integer) As Integer
'============================================================================================
Private Sub Main()
' find out what to do...register or unregister
  Dim Buffer As String
  Dim FileName As String
  
  Buffer = String(255, 0)
  GetFileTitle CStr(Command), Buffer, Len(Buffer)
  Buffer = Left$(Buffer, InStr(1, Buffer, Chr$(0)) - 1)
  FileName = Buffer
  
  If CStr(Command) = "" Then
    MsgBox "No TypeLibraries Specified", vbCritical, "Error: No TypeLib"
    Exit Sub
  End If
  If InStrRev(CStr(Command), "/u") = 0 Then
    RegisterMe CStr(Command), FileName
  Else
    FileName = Left(Buffer, Len(Buffer) - 3)
    UnregisterMe CStr(Command), FileName
  End If
End Sub ' Main()
'============================================================================================
Private Sub RegisterMe(FilePath As String, FileName As String)
' register the type library
  Dim ResultMessage As Long
  Dim TypeLibraryPointer As Object
  Dim TypeLibraryPath() As Byte
  
  TypeLibraryPath = FilePath & vbNullChar
  ResultMessage = LoadTypeLib(TypeLibraryPath(0), TypeLibraryPointer)
  
  If ResultMessage = 0 Then
    ResultMessage = RegisterTypeLib(TypeLibraryPointer, TypeLibraryPath(0), 0)
  End If
  If ResultMessage = 0 Then
    MsgBox "Successful Registration of Type Library: " & FileName, vbInformation, "Registration Successful"
  Else
    MsgBox "Registration of Type Library: " & FileName & " Unsuccessful", vbInformation, "Registration Unsuccessful"
  End If
End Sub ' RegisterMe(FilePath As String, FileName As String)
'============================================================================================
Private Sub UnregisterMe(FilePath As String, FileName As String)
' unregister the type library
  Dim ResultMessage As Long
  Dim TypeLibraryPath() As Byte
  Dim TypeLibraryInfo As TypeLibInfo
  Dim TypeLibraryGUID As GUID
  Dim TypeLibraryCLSID As String
  Dim TypeLibraryMajor As Integer
  Dim TypeLibraryMinor As Integer
  Dim TypeLibraryCID As Long
    
  TypeLibraryPath = Left(FilePath, Len(FilePath) - 3)
  Set TypeLibraryInfo = TLI.TypeLibInfoFromFile(TypeLibraryPath)
  TypeLibraryCLSID = TypeLibraryInfo.GUID
  TypeLibraryMajor = TypeLibraryInfo.MajorVersion
  TypeLibraryMinor = TypeLibraryInfo.MinorVersion
  TypeLibraryCID = TypeLibraryInfo.lCID
  Set TypeLibraryInfo = Nothing
    
  TypeLibraryPath = TypeLibraryCLSID & vbNullChar
  ResultMessage = CLSIDFromString(TypeLibraryPath(0), TypeLibraryGUID)
  If ResultMessage = 0 Then
    ResultMessage = UnRegisterTypeLib(TypeLibraryGUID, TypeLibraryMajor, TypeLibraryMinor, TypeLibraryCID, SYS_WIN32)
  End If
  If ResultMessage = 0 Then
    MsgBox "Successful Unregister of Type Library: " & FileName, vbInformation, "Unregister Successful"
  Else
    MsgBox "Unregister of Type Library: " & FileName & " Unsuccessful", vbInformation, "Unregister Unsuccessful"
  End If
End Sub ' UnregisterMe(FilePath As String, FileName As String)
'============================================================================================

